using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Media;
using Avalonia.Media.Imaging;
using System;
using System.Data;
using System.Diagnostics;
using System.Runtime.Intrinsics.Arm;
using Avalonia.Threading;
using System.Runtime.InteropServices;
using System.Threading.Tasks;
using Tmds.DBus.Protocol;
using System.IO;

namespace AvaloniaApplication1
{
    struct DateB
    {
        int dayB;
        int monthB;
        int yearB;
    }
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
            
        }
       
        public void Button_Click(object source, RoutedEventArgs args)
        {
            string date = dateT.SelectedDate.ToString();

            if (date == "")
            {
                Error.Text = "   ";
            }
            else
            {
                int day = int.Parse(date.Substring(0, 2));
                int mounth = int.Parse(date.Substring(3, 2));
                int year = int.Parse(date.Substring(6, 4));

                DateTime BD = new DateTime(year, mounth, day);
                DateTime ToDay = DateTime.Now;


                if (BD > ToDay)
                {
                    Error.Text = "   ";
                }
                else
                {
                    Error.Text = "";
                    int Vis = 0;
                    int DbWeek = 0;
                    DateTime dayW;
                    int age = ToDay.Year - BD.Year;
                    int months = ToDay.Month - BD.Month;
                    int days = ToDay.Day - BD.Day;

                    if (ToDay.Month < BD.Month || (ToDay.Month == BD.Month && ToDay.Day < BD.Day))
                    {
                        age--;
                    }

                    if (days < 0)
                    {
                        months--;
                        days += DateTime.DaysInMonth(ToDay.Year, ToDay.Month - 1);
                    }

                    if (months < 0)
                    {
                        months += 12;
                    }
                    VisY.Text = " : ";
                    string DayOfWeek = BD.DayOfWeek.ToString();
                    for (int i = year; i <= ToDay.Year; i++)
                    {
                        if (i % 4 == 0)
                        {

                            VisY.Text = VisY.Text + i + " ";
                            Vis++;
                        }
                        dayW = new DateTime(i, mounth, day);

                        if (dayW.DayOfWeek.ToString() == DayOfWeek && dayW != BD && dayW != ToDay)
                        {
                            DbWeek++;
                        }
                    }

                    if (DayOfWeek == "Monday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Tuesday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Wednesday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Thursday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Friday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Saturday")
                    {
                        DayOfWeek = "";
                    }
                    if (DayOfWeek == "Sunday")
                    {
                        DayOfWeek = "";
                    }

                    dayOfWeek.Text = " : " + DayOfWeek;
                    yearT.Text = " : " + age.ToString();
                    mounthT.Text = " : " + months.ToString();
                    daysT.Text = " : " + days.ToString();
                    DBW.Text = "     " + DayOfWeek + ": " + DbWeek;
                    Viss.Text = "  : " + Vis;
                }
                if(Zod.IsChecked == false && Vost.IsChecked == false)
                {

                }
                if(Vost.IsChecked == true)
                {
                    string Zod = " ";
                    string[] ZnakV = new string[]
                    {
                        "", "", "", "", "",
                        "", "", "", "", "",
                        "", ""
                    };
                    int index = (year-4) % 12;
                    Znak.Text = "  : " + ZnakV[index];
                }
                if (Zod.IsChecked == true)
                {
                    string Zod = " ";
                    if(day >= 21 && mounth == 3 || day <= 19 && mounth == 4)
                    {
                        Zod = ""; 

                    }
                    if (day >= 20 && mounth == 4 || day <= 20 && mounth == 5)
                    {
                        Zod = "";
                    }
                    if (day >= 21 && mounth == 5 || day <= 20 && mounth == 6)
                    {
                        Zod = "";
                    }
                    if (day >= 21 && mounth == 6 || day <= 22 && mounth == 7)
                    {
                        Zod = "";
                    }
                    if (day >= 23 && mounth == 7 || day <= 22 && mounth == 8)
                    {
                        Zod = "";
                    }
                    if (day >= 23 && mounth == 8 || day <= 22 && mounth == 9)
                    {
                        Zod = "";
                    }
                    if (day >= 23 && mounth == 9 || day <= 22 && mounth == 10)
                    {
                        Zod = "";
                    }
                    if (day >= 23 && mounth == 10 || day <= 21 && mounth == 11)
                    {
                        Zod = "";
                    }
                    if (day >= 22 && mounth == 11 || day <= 21 && mounth == 12)
                    {
                        Zod = "";
                    }
                    if (day >= 22 && mounth == 12 || day <= 19 && mounth == 1)
                    {
                        Zod = "";
                    }
                    if (day >= 20 && mounth == 1 || day <= 18 && mounth == 2)
                    {
                        Zod = "";
                    }
                    if (day >= 19 && mounth == 2 || day <= 20 && mounth == 3)
                    {
                        Zod = "";
                    }

                    Znak.Text = " : " + Zod;
                }

            }
            
        }

        [Obsolete]
        public async void File(object source, RoutedEventArgs args)
        {
            string path;
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.AllowMultiple = false;
            OFD.Filters.Add(new FileDialogFilter() { Name = "CSV ", Extensions = { "csv" } });
            var result = await OFD.ShowAsync(this);
            if (result != null)
            {
                path = result[0];
                using(StreamReader sr = new StreamReader(path))
                {
                    int k = 0;
                    string line = sr.ReadLine();
                    while (line != null)
                    {
                        if (string.IsNullOrWhiteSpace(line))
                        {
                            k++;
                        }
                        line = sr.ReadLine();
                    }
                    Por.Text = k.ToString();
                };
            }          
        }
    }
}